- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# route53_zone – add or delete Route53 zones

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Creates and deletes Route53 private and public zones

## Requirements

The below requirements are needed on the host that executes this module.

- boto

- boto3

- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
comment - | Default: "" | Comment associated with the zone
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
delegation_set_id - added in 2.6 |  | The reusable delegation set ID to be associated with the zone. Note that you can't associate a reusable delegation set with a private hosted zone.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
hosted_zone_id - added in 2.4 |  | The unique zone identifier you want to delete or "all" if there are many zones with the same domain name. Required if there are multiple zones identified with the above options
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
state - | Choices: present ← absent | whether or not the zone should exist or not
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.
vpc_id - |  | The VPC ID the zone should be a part of (if this is going to be a private zone)
vpc_region - |  | The VPC Region the zone should be a part of (if this is going to be a private zone)
zone - / required |  | The DNS zone record (eg: foo.com.)

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`

- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html

- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: create a public zone
      route53_zone:
        zone: example.com
        comment: this is an example

    - name: delete a public zone
      route53_zone:
        zone: example.com
        state: absent

    - name: create a private zone
      route53_zone:
        zone: devel.example.com
        vpc_id: '{{ myvpc_id }}'
        vpc_region: us-west-2
        comment: developer domain

    - name: create a public zone associated with a specific reusable delegation set
      route53_zone:
        zone: example.com
        comment: reusable delegation set example
        delegation_set_id: A1BCDEF2GHIJKL

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
comment string | when hosted zone exists | optional hosted zone comment Sample: Private zone
delegation_set_id string | for public hosted zones, if they have been associated with a reusable delegation set | id of the associated reusable delegation set Sample: A1BCDEF2GHIJKL
name string | when hosted zone exists | hosted zone name Sample: private.local.
private_zone boolean | when hosted zone exists | whether hosted zone is private or public Sample: True
vpc_id string | for private hosted zone | id of vpc attached to private hosted zone Sample: vpc-1d36c84f
vpc_region string | for private hosted zone | region of vpc attached to private hosted zone Sample: eu-west-1
zone_id string | when hosted zone exists | hosted zone id Sample: Z6JQG9820BEFMW

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]

- This module is maintained by the Ansible Community. [community]

### Authors

- Christopher Troup (@minichate)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.